// ////////////////////////////////////////////////////
//
// StdView.cpp : implementation of the CStdView class
// Based on class COGLView : public CView
// Inspect COGLView for standard OpenGL initialization
//
////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"

#include "StdDoc.h"
#include "StdView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////
// You can put definitions, variables and helperfunctions
// here. Functions that does not rely on CStdView member
// variables or functions
//////////////////////////////////////////////
// helper to draw a box

void DrawBox()
{
	// draws the sides of a unit cube (0,0,0)-(1,1,1)

	glBegin(GL_POLYGON);//f1: front
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);//f2: bottom
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f3:back
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f4: top
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f5: left
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f6: right
		glNormal3f(0.0f,-1.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,1.0f,0.0f);
	glEnd();
}

//////////////////////////////////////////////////////////
// CStdView

IMPLEMENT_DYNCREATE(CStdView, COGLView)

BEGIN_MESSAGE_MAP(CStdView, COGLView)
	//{{AFX_MSG_MAP(CStdView)
	ON_COMMAND(ID_MATERIALER_BOKSER, OnMaterialerBokser)
	ON_COMMAND(ID_MATERIALER_BORD, OnMaterialerBord)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////
// CStdView construction/destruction

CStdView::CStdView()
{
	// initialize material, 
	// see menuhandlers and Drawscene
	m_BordMatIx=YELLOW_PLASTIC;
	m_KlossMatIx=BRASS;
	// initialize angles, see DrawScene
	m_xv=-60.0f;
	m_yv=0.0f;
	
	m_hRC=NULL;
	m_hDC=NULL;

};

CStdView::~CStdView()
{}

////////////////////////////////////////////////////////////
// CStdView diagnostics
// You should usually not touch these:
#ifdef _DEBUG
void CStdView::AssertValid() const
{COGLView::AssertValid();}
void CStdView::Dump(CDumpContext& dc) const
{COGLView::Dump(dc);}

CStdDoc* CStdView::GetDocument() // non-debug version is inline
{	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStdDoc)));
	return (CStdDoc*)m_pDocument;
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////
// CStdView operations

void CStdView::DrawScene()
{
	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	// Set up for scene
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	
	gluLookAt(-4.0f,-5.0f,6.0f,// eye
            0.0f,0.0f,0.0f,  // looking at
            0.0f,0.0f,1.0f   // is up
            );
	

	//////////////////////////////////
	// Alternative: bring construction in position

	// Based on:	default eye is at 0,0,0, 
	//				looking twds negative z-axis

	// move the construction down z
	// glTranslatef(0.0f,0.0f,-8.0f);
	///////////////////////////////////

	// rotate around x-axis 
	glRotatef(m_xv,1.0f,0.0f,0.0f);
	// rotate around z-axis 
	glRotatef(m_yv,0.0f,0.0f,1.0f);
	
	/////////////////////////////
	// Draw the construction
	
	// draw the "table"
	// set material for table
	CMaterial::SetMaterial(m_BordMatIx);
	glPushMatrix();
	glTranslatef(-3.5f,-1.0f,-0.11f);
	glScalef(7.0f,3.0f,0.1f);
	DrawBox();
	glPopMatrix();
	// set material for boxes
	CMaterial::SetMaterial(m_KlossMatIx);
	// the first box
	glPushMatrix();
	glTranslatef(-2.5f,0.0f,0.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();
	glPopMatrix();
	// the second box
	glPushMatrix();
	glTranslatef(0.5f,0.0f,0.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();
	glPopMatrix();
	// the box on top
	glTranslatef(-1.0f,0.0f,1.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();

	// End draw the construction
	/////////////////////////////


	// finnish drawing
	glFlush();
}

void CStdView::InitializeRContext()
{
	// Here we set the attributes that will be constant
	// during the rendering contexts lifetime
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    
	// prepare ligthsource
	GLfloat ambient[] = {0.2f,0.2f,0.2f,1.0f };
    GLfloat diffuse[] = {1.0f,1.0f,1.0f,1.0f };
    GLfloat position[] = {4.0f,0.0f,6.0f,0.0f };
	GLfloat lmodel_ambient[] = {0.4f,0.4f,0.4f,1.0f };


    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position);
	
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	// smooth the drawing
	glShadeModel(GL_SMOOTH);
	glEnable(GL_NORMALIZE);

    // set background to light gray
	glClearColor(0.8f, 0.8f, 0.8f, 0.0f);
}

void CStdView::SetPerspective(int cx,int cy)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluPerspective(50.0f, (GLdouble)cx/cy, 0.1f, 70.0f);
	//gluPerspective(50.0f, 1.0f, 0.1f, 70.0f);
	glMatrixMode(GL_MODELVIEW);
}


void CStdView::OnMaterialerBokser() 
{
	CMaterial m;
	if(m.DoModal()==IDOK)
	{
		Invalidate(NULL);
		m_KlossMatIx=m.Get_Current_Index();
	}
}

void CStdView::OnMaterialerBord() 
{
	CMaterial m;
	if(m.DoModal()==IDOK)
	{
		Invalidate(NULL);
		m_BordMatIx=m.Get_Current_Index();
	}
}

void CStdView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed left button.Make a note
	// of this and prepare for intuitive rotation of scene
	m_PLast=point;
	SetCapture();
	CView::OnLButtonDown(nFlags, point);
}

void CStdView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and terminate rotation
	ReleaseCapture();
	CView::OnLButtonUp(nFlags, point);
}

void CStdView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down 
	if(nFlags && MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>2)||(abs(m_PLast.y-point.y)>2))
		{
			// then we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);
			
			m_yv+=90.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_xv+=90.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			
			// rememeber point and force immediate redraw 
			m_PLast=point;
			RedrawWindow();
		}
	}
}
